---
layout: default
title: Модуль «Комментарии»
nav_order: 2
parent: Плагины (модули) Cetera CMS
grand_parent: Руководство разработчика
---

# Модуль «Комментарии»

Позволяет добавлять комментарии к материалам сайта.

При установке модуль добавляет тип материалов «comments», в котором хранятся комментарии.

## Добавляет в класс \Cetera\Material методы

Метод | Описание
---|---
**getComments()**|Возвращает итератор \Cetera\Iterator\Material с комментариями к материалу
**getCommentsCount()**|Возвращает кол-во комментариев, синоним getComments()→getCountAll()
**addComment($text,$publish=true,$user=null,$nickname)**|Добавляет комментарий к материалу. $text — текст комментария, $publish — флаг публикации комментария, $user — автор, комментария (если не указан, то используется \Cetera\Application::getUser())), $nickname — псевдоним автора (для неавторизованных пользователей)

## ВиджетComments.Add

В модуле «Комментарии» это виджет формы для комментирования материала .

### Пример вызова Twig

	{% raw %}{% widget 'Comments.Add' with { material: article } %}{% endraw %}
 

Параметр | Описание
---|---
**template**|Шаблон вывода
**material**|Материал, к которому оставлять комментарий. Объект класса \Cetera\Material
**material_type**|Тип материала
**material_id**|ID материала
**catalog**|Раздел, в котором находится материал
**material_alias**|Алиас материала
**publish**|`[TRUE|FALSE]` Сразу публиковать отправленный комментарий. По умолчанию **TRUE**
**ajax**|`[TRUE|FALSE]` Отправка комментария без перезагрузки страницы. По умолчанию **FALSE**
**submit_text**|Текст на кнопке отправки комментария. По умолчанию «Отправить сообщение»
**success_text**|Сообщение об успешной отправке комментария. По умолчанию «Ваш комментарий принят»

Для того, чтобы выбрать материал, к которому будут отправляться комментарии, используйте параметры:

* **material** — явная передача материала
* **material_type и material_id** — поиск материала по типу и ID или
* **catalog и material_alias** — поиск материала по разделу и алиасу

## Виджет Comments.List

В модуле «Комментарии» это виджет списка комментариев к материалу.

Параметр | Описание
---|---
**template**|Шаблон вывода
**material**|Материал. Объект класса \Cetera\Material
**material_type**|Тип материала
**material_id**|ID материала
**catalog**|Раздел, в котором находится материал
**material_alias**|Алиас материала
**ajax**|`[TRUE|FALSE]` AJAX-режим. По умолчанию **FALSE**
**order**|Поле сортировки комментариев. По умолчанию **dat**
**sort**|`[ASC|DESC]` Порядок сортировки комментариев. По умолчанию **DESC**
**limit**|Комментариев на странице. 0 — показать все. По умолчанию **10**
**page**|Показать страницу, при установленном параметре limit, По умолчанию — из **$_REQUEST[page_param]**
**page_param**|Имя параметра, в котором передавать № страницы. По умолчанию **page**
**paginator**|`[TRUE|FALSE]` Показать постраничную навигацию. По умолчанию **FALSE**
**paginator_url**|Формат ссылок на страницы. {material} — заменяется на url материала, {page} — на № страницы. По умолчанию **{material}?page={page}**
**paginator_template**|Шаблон пагинатора
**form**|`[TRUE|FALSE]` Показать форму добавления комментария **TRUE**
**form_template**|Шаблон формы
**form_title**|Заголовок формы. По умолчанию Добавить комментарий
**form_publish**|`[TRUE|FALSE]` Сразу публиковать отправленный комментарий. По умолчанию **TRUE**
**form_submit_text**|Текст на кнопке отправки комментария. По умолчанию «Отправить сообщение»
**form_success_text**|Сообщение об успешной отправке комментария. По умолчанию «Ваш комментарий принят»