---
layout: default
title: Модуль «Рассылки»
nav_order: 8
parent: Плагины (модули) Cetera CMS
grand_parent: Руководство разработчика
---

# Модуль «Рассылки»

Позволяет осуществлять почтовые рассылки.

Ссылка для отписки в теле письма:

{unsubscribe_link}

## Класс \Mail_lists\Newsletter

Метод | Описание
---|---
**enum()**|Статический метод. Возвращает список всех созданных рассылок.
**getById()**|Статический метод. Ищет рассылку по ID.
**subscribe($user)**|Подписывает пользователя на рассылку.
**unsubscribe($user)**|Отписывает пользователя от рассылки.
**isSubscribed($user)**|Подписан ли пользователь на рассылку.

## Виджет MailList.Subscribe

Виджет формы для подписки на рассылки

### Пример вызова Twig

	{% raw %}{% widget 'MailList.Subscribe' with { newsletters_select: true } %}{% endraw %}

Параметр | Описание
**template**|Шаблон вывода
**newsletters**|Рассылки, на которые подписывать в формате «ID1,ID2,…,IDn» По умолчанию — все рассылки
**newsletters_select**|[true/false] Показывать список рассылок, давая пользователю выбрать, на что подписаться. По умолчанию — false
**subscribe_text**|Текст на кнопке отправки формы. По умолчанию — «Подписаться»
**ajax**|[true/false] Режим AJAX. По умолчанию — false

## Изменение шаблонов писем для рассылки

Чтобы изменить шаблон рассылаемых писем, вызовите окно свойств рассылки.

В поле «Заголовок письма» введите текст, который будет виден как Subject в рассылаемых письмах. На закладке «Шаблон письма» введите шаблон, по которому будет составляться содержание писем. Шаблон составляется по следующему принципу:

	[Приветственная часть письма]
	<loop name="materials">
	[Повторяющийся текст]
	</loop name="materials">
	[Заключительная часть письма]
                       
1. В блоке [Приветственная часть письма] поместите вводный текст.
2. Блок [Повторяющийся текст] будет повторяться столько раз, сколько материалов рассылается в эту рассылку. В этом блоке необходимо расставить переменные, вместо которых будет подставляться содержание полей рассылаемых материалов. Переменные должны быть заключены в фигурные скобки {}. Названия переменных должны совпадать с названиями полей рассылаемых материалов. Например, переменная {name}, встретившаяся в блоке повторяющегося текста, будет заменена на заголовок материала. Названия полей, используемые в материалах, уточните у разработчика вашего сайта.
	Дополнительная переменная, которую можно использовать в блоке повторяющегося текста — {path_to}, эта переменная в процессе рассылки заменяется на путь к разделу на сервере с рассылаемым материалом, например, при рассылке материалов из подраздела news раздела company, значение переменной

3. В блоке [Заключительная часть письма] можно разместить информацию о том как можно отписаться от рассылки, контактную информацию и т.д.