---
layout: default
title: List
nav_order: 19
parent: Виджеты
grand_parent: Руководство разработчика
---

# List

Выводит список материалов в заданном количестве и в заданной последовательности.

## Пример вызова PHP

	\Cetera\Application::getInstance()->getWidget('List', [array](http://php.net/array)(
	    'catalog'   => 0,
	    'limit'     => 5,
	    'order'     => 'dat',
	    'sort'      => 'DESC',
	    'paginator' => true,
	))->display();

## Пример вызова Twig

	{% raw %}{% widget 'List' with { limit:6, paginator:1, template: 'tiles.twig' } %}{% endraw %}

## Описание параметров

Параметр | Описание
---|---
**template**|Шаблон вывода
**css_class**|Класс, который будет прописан у корневого элемента в шаблоне виджета
**catalog**|Раздел, из которого выводить материалы. 0 — для текущего раздела. По умолчанию **0**
**limit**|Ограничение кол-ва материалов. 0 — без ограничения. По умолчанию **10**
**page**|№ страницы, если используется ограничение кол-ва материалов. По умолчанию **1**
**order**|Поле, по которому сортировать список. По умолчанию **dat**
**sort**|`[ASC|DESC]` Порядок сортировки. По умолчанию **DESC**
**subsections**|`[true|false]` Показать материалы из подразделов. По умолчанию **false**
**where**|Устаревший параметр, используйте "filter". Фильтр материалов. В SQL запрос добавляется условие указанное условие WHERE
**filter**|Для опытных пользователей! Позволяет дополнительно отфильтровать или отсортировать список материалов. Здесь можно непосредственно вызвать любой метод или несколько методов, описанных в статье Итераторы.
**iterator**|Объект \Cetera\Iterator\Material по списком материалов
**paginator**|`[true|false]` Показать постраничную навигацию. По умолчанию **false**
**paginator_template**|Шаблон виджета постраничной навигации
**ajax**|`[true|false]` AJAX-навигация по страницам. По умолчанию **false**
**infinite**|`[true|false]` Режим бесконечной подгрузки страниц. Работает при включенной опции ajax. Используется шаблон постраничной навигации infinite.twig, если не задан другой в параметре paginator_template
**catalog_link**|Показать ссылку на раздел. По умолчанию **false**

## Встроенные шаблоны

Название|Описание
---|---
**default.twig**|Выводит названия материалов в виде блоков DIV. Шаблон по умолчанию
**tiles.twig**|Выводит материалы в виде плитки по 3 в строку (паттерн Block Grid в Foundation 6) с выравниванием высоты. http://foundation.zurb.com/sites/docs/grid.html#block-grids
**menu.twig**|Выводит названия материалов в виде маркированного списка UL