---
layout: default
title: Section
nav_order: 11
parent: Виджеты
grand_parent: Руководство разработчика
---

# Section

Виджет позволяет организовать просмотр материалов раздела сайта. Для отображения материалов используется виджет «Material», для отображения списка материалов — виджет «List»

*CeteraCMS 3.22+*

## Пример вызова в PHP

	\Cetera\Application::getInstance()->getWidget('Section', array(
	))->display();

## Пример вызова в Twig

	{% raw %}{% widget 'Section' with {  } %}{% endraw %}

## Описание параметров

Параметр | Описание
---|---
**template**|Шаблон вывода
**catalog**|Раздел сайта. По умолчанию — текущий раздел
**display_index**|`true|false` Показывать материал с alias=index, если не указан другой материал. При значении *false* и отсутствии материала показывается список материалов раздела. По умолчанию *true*
**material_template**|Шаблон виджета «Material» для отображения материала /
**material_id**|ID материала . По умолчанию *null*
**material_alias**|alias материала. По умолчанию используется Application::getUnparsedUrl()
**material_share_buttons**|`true|false` Показать кнопки расшаривания материалов в соцсети. По умолчанию *false*
**material_show_pic**|`true|false` Показать иллюстрацию (поле pic у материала). По умолчанию *false*
**list_template**|Шаблон виджета «List» для отображения списка материалов
**list_limit**|Ограничение кол-ва материалов. 0 — без ограничения. По умолчанию **10**
**list_page**|№ страницы, если используется ограничение кол-ва материалов. По умолчанию **1**
**list_order**|Поле, по которому сортировать список. По умолчанию *dat*
**list_sort**|`[ASC**|DESC]` Порядок сортировки. По умолчанию **DESC**
**list_where**|Фильтр списка материалов. В SQL запрос добавляется условие указанное условие WHERE
**list_paginator**|[`true|false`] Показать постраничную навигацию. По умолчанию **true**
**list_subsections**|[`true|false`] Показывать материалы из подразделов в списке. По умолчанию **false**
**paginator_template**|Шаблон виджета постраничной навигации
**page404_template**|Шаблон с текстом в случае, если материал не найден

## Встроенные шаблоны

Название | Описание
---|---
**default.twig**|Шаблон по умолчанию
